com.amazonaws.services.cloudfront.model

## Class CachedMethods

- java.lang.Object
- - com.amazonaws.services.cloudfront.model.CachedMethods

All Implemented Interfaces:
  Serializable, Cloneable

    public class CachedMethods
    extends Object
    implements Serializable, Cloneable

A complex type that controls whether CloudFront caches the response to requests using the specified HTTP methods. There are two choices:

- CloudFront caches responses to `GET` and `HEAD` requests.

- CloudFront caches responses to `GET`, `HEAD`, and `OPTIONS` requests.

If you pick the second choice for your Amazon S3 Origin, you may need to forward Access-Control-Request-Method, Access-Control-Request-Headers, and Origin headers for the responses to be cached correctly.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`CachedMethods()`

### Method Summary

All Methods Instance Methods Concrete Methods
`CachedMethods` `clone()`
`boolean` `equals(Object obj)`
`List<String>` `getItems()` A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
`Integer` `getQuantity()` The number of HTTP methods for which you want CloudFront to cache responses.
`int` `hashCode()`
`void` `setItems(Collection<String> items)` A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
`void` `setQuantity(Integer quantity)` The number of HTTP methods for which you want CloudFront to cache responses.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`CachedMethods` `withItems(Collection<String> items)` A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
`CachedMethods` `withItems(Method... items)` A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
`CachedMethods` `withItems(String... items)` A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
`CachedMethods` `withQuantity(Integer quantity)` The number of HTTP methods for which you want CloudFront to cache responses.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### CachedMethods

    public CachedMethods()

### Method Detail

#### setQuantity

    public void setQuantity(Integer quantity)

The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).

Parameters:
  `quantity` - The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).

#### getQuantity

    public Integer getQuantity()

The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).

Returns:
  The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).

#### withQuantity

    public CachedMethods withQuantity(Integer quantity)

The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).

Parameters:
  `quantity` - The number of HTTP methods for which you want CloudFront to cache responses. Valid values are `2` (for caching responses to `GET` and `HEAD` requests) and `3` (for caching responses to `GET`, `HEAD`, and `OPTIONS` requests).
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### getItems

    public List<String> getItems()

A complex type that contains the HTTP methods that you want CloudFront to cache responses to.

Returns:
  A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
See Also:
  `Method`

#### setItems

    public void setItems(Collection<String> items)

A complex type that contains the HTTP methods that you want CloudFront to cache responses to.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
See Also:
  `Method`

#### withItems

    public CachedMethods withItems(String... items)

A complex type that contains the HTTP methods that you want CloudFront to cache responses to.

NOTE: This method appends the values to the existing list (if any). Use `setItems(java.util.Collection)` or `withItems(java.util.Collection)` if you want to override the existing values.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### withItems

    public CachedMethods withItems(Collection<String> items)

A complex type that contains the HTTP methods that you want CloudFront to cache responses to.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### withItems

    public CachedMethods withItems(Method... items)

A complex type that contains the HTTP methods that you want CloudFront to cache responses to.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to cache responses to.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public CachedMethods clone()

Overrides:
  `clone` in class `Object`